require 'test/unit'
include Test::Unit
require 'enumerator'

require 'gstudier.rb'

$QUESTIONS = <<EOF
Q:Koliko starim ljudjem hkrati nudite pomoč več kot 5 ur tedensko?
A:%d

Q:Koliko ljdujem, poleg stari osebi, še nudite podporo in oskrbo (npr. otrokom itd.)
A:%b

Q:{4a}V kakšnen sorodstvenem odnosu ste s staro osebo, ki jo oskrbujete?
A:sem zakonec/partner-ica
A:sem brat/sestra
A:sem otrok (hči/sin)
A:sem nečak/nečakinja
A:nisem v sorodstveni zvezi -sem njen/a %s
A:drugo %text

Q:Kaj je glavni razlog, da ste se odločili za oskrbovanje starega človeka?
q:Občutek dolžnosti %B
q:Stara oseba ni želela, da bi jo oskrboval kdo drug %b
q:Čustvena povezanost (ljubezen, hvaležnost) %B

Q:V Sloveniji so številni programi za pomoč in oskrbo starim ljudem. Katere so oblike pomoči, ki jih uporabljate/koristite?
q:dnevno varstvo [da|ne, ker te storitve ne poznam|ne, ker ne me zanima|ne, ker je storitev preveč draga|ne, ker storitev ni na voljo|ne, še ni potrebe|drugo|b.o.]
q:pomoč in nega na domu [da|ne, ker te storitve ne poznam|ne, ker ne me zanima|ne, ker je storitev preveč draga|ne, ker storitev ni na voljo|ne, še ni potrebe|drugo|b.o.]
q:"rdeči gumb" - telefon za pomoč na daljavo [da|ne, ker te storitve ne poznam|ne, ker ne me zanima|ne, ker je storitev preveč draga|ne, ker storitev ni na voljo|ne, še ni potrebe|drugo|b.o.]

Q:Prosimo vas, da napišite tisto, kar bi želeli še dodati, pa vas po tem nismo povpršali.
A:%text

Q:What do you prefer?
q:cats %order
q:dogs %order
q:kangaroos %order
EOF

$SAVED_ANSWERS = <<EOF11

  <results>
    <single_val question='1' value='5'/>
    <single_val question='2' value='no'/>
    <choice_val question='4a' index='0'/>
    <fill_all_values question='4'>
      <value bool_no_bo='no'/>
      <value bool='no'/>
      <value bool_no_bo='yes'/>
    </fill_all_values>
    <fill_all_values question='5'>
      <value alts='0'/>
      <value alts='0'/>
      <value alts='0'/>
    </fill_all_values>
    <single_val question='6' value='25'/>
    <fill_all_values question='7'>
      <value order='0'/>
      <value order='0'/>
      <value order='0'/>
    </fill_all_values>
  </results>
EOF11

$QUESTION_15a = <<EOF111
Q:{15-2}Pri katerih opravilih star človek rabi pomoč in kdo jo nudi?
q:GOSPODINJSKA pomoč (kuhanje, pomivanje,likanje, pranje, pospravljanje,…) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:razna DOMAČA OPRAVILA (vrtnarjenje, hišna popravila,..) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:OSEBNA HIGIENA in NEGA (umivanje,oblačenje, pomoč pri hranjenju, kopanje, odhod na WC) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:DOMAČA ZDRAVSTVENA pomoč (dajanje zdravil, prevezovanje, razgibavanje, merjenje pritiska/sladkorja,...) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:DUŠEVNA  in ČUSTVENA opora  {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:MEDČLOVEŠKA opora (druženje, da ni sam; poslušanje njegovih zgodb/izkušenj; pripovedovanje informacij,…) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:pomoč pri gibanju - MOBILNOSTI (v stanovanju in zunaj njega; sprehodi, obisk trgovine,...) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:UREJANJE FINANČNIH ZADEV (plačevanje računov z denarjem starega človeka) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:FINANČNA PODPORA (dajanje svojega denarja stari osebi,...) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:ADMINISTRATIVNA pomoč (urejanje po uradih; pisanje formularjev, pomoč pri organizaciji, urejanju dokumentov,…) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
EOF111

$SAVED_ANSWERS_15a = <<EOFAA

  <results>
    <fill_all_values question='15-2'>
      <value>
        <values>
          <subval>0</subval>
          <subval>1</subval>
          <subval>2</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>1</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>2</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>3</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>4</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>3</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>2</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>1</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>0</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>1</subval>
        </values>
      </value>
    </fill_all_values>
  </results>
EOFAA

# 15b is different from 15a because the choices are not all
# the same in 15b (jaz/jz for instance), so we don't display by a listview
# but a list of checkboxes => completely different code.
$QUESTION_15b = <<EOF111
Q:{15-2}Pri katerih opravilih star človek rabi pomoč in kdo jo nudi?
q:GOSPODINJSKA pomoč (kuhanje, pomivanje,likanje, pranje, pospravljanje,…) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedo drug|nihče}
q:razna DOMAČA OPRAVILA (vrtnarjenje, hišna popravila,..) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:OSEBNA HIGIENA in NEGA (umivanje,oblačenje, pomoč pri hranjenju, kopanje, odhod na WC) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:DOMAČA ZDRAVSTVENA pomoč (dajanje zdravil, prevezovanje, razgibavanje, merjenje pritiska/sladkorja,...) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:DUŠEVNA  in ČUSTVENA opora  {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:MEDČLOVEŠKA opora (druženje, da ni sam; poslušanje njegovih zgodb/izkušenj; pripovedovanje informacij,…) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:pomoč pri gibanju - MOBILNOSTI (v stanovanju in zunaj njega; sprehodi, obisk trgovine,...) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:UREJANJE FINANČNIH ZADEV (plačevanje računov z denarjem starega človeka) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:FINANČNA PODPORA (dajanje svojega denarja stari osebi,...) {jz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
q:ADMINISTRATIVNA pomoč (urejanje po uradih; pisanje formularjev, pomoč pri organizaciji, urejanju dokumentov,…) {jaz|nek plačani uslužbenec|družinski član/sorodnik|nedko drug|nihče}
EOF111

$SAVED_ANSWERS_15b = <<EOFAA

  <results>
    <fill_all_values question='15-2'>
      <value>
        <values>
          <subval>0</subval>
          <subval>1</subval>
          <subval>2</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>1</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>2</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>3</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>4</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>3</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>2</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>1</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>0</subval>
        </values>
      </value>
      <value>
        <values>
          <subval>1</subval>
        </values>
      </value>
    </fill_all_values>
  </results>
EOFAA

$QUESTIONS_DEPS = <<EOF1
Q:do you like pets?
A:yes
A:no   => 2
A:b.o. => 2

Q:which ones?
A:cats
A:dogs
A:lions
A:penguins

Q:do you like people?
A:%b
EOF1

def strip_lines(str)
	enum = Enumerable::Enumerator.new(str, :each_line)
	enum.map {|l| l.strip}.join("\n")
end

class TC_GStudier < TestCase

	def test1()
		questions = Studier::parse_questions($QUESTIONS)
		assert(questions.size == 7)

 		entries = REXML::Document.new($SAVED_ANSWERS)
		main = GStudierDialog.new(questions, entries)
		assert( strip_lines(main.save_entries_to_str()+"\n") == 
		      strip_lines($SAVED_ANSWERS) )
	end

	def test15a()
		questions = Studier::parse_questions($QUESTION_15a)
		assert(questions.size == 1)

 		entries = REXML::Document.new($SAVED_ANSWERS_15a)
		main = GStudierDialog.new(questions, entries)
		assert(strip_lines(main.save_entries_to_str()+"\n") == 
		       strip_lines($SAVED_ANSWERS_15a))
	end

	def test15b()
		questions = Studier::parse_questions($QUESTION_15b)
		assert(questions.size == 1)

 		entries = REXML::Document.new($SAVED_ANSWERS_15b)
		main = GStudierDialog.new(questions, entries)
		assert(strip_lines(main.save_entries_to_str()+"\n") == 
		       strip_lines($SAVED_ANSWERS_15b))
	end
end

Gtk.init

require 'test/unit/ui/console/testrunner'
UI::Console::TestRunner.run(TC_GStudier)
