require 'plugins/export/shared/exportbase.rb'

class Openanswers < ExportBase
	def export_desc()
		"open answers"
	end

	def extension()
		"csv"
	end

	# true if i support exporting only few questionnaries,
	# exporting only the selection.
	def support_export_selection()
		false
	end

	def export(_xml_tree, tv, questions, file, export_selected_if_possible)
		# start with q4, choices 6 & 7
		export_all_text_choices(_xml_tree, '4', 6, file)
		export_all_text_choices(_xml_tree, '4', 7, file)
		export_all_text_choices(_xml_tree, '7', 8, file)
		export_all_text_several_q(_xml_tree, '8', 6, file)
		export_all_text_several_q(_xml_tree, '10a', 2, file)
		export_all_text_several_q(_xml_tree, '10a', 3, file)
		export_all_text_several_q(_xml_tree, '10a', 4, file)
		export_all_text_several_q(_xml_tree, '10a', 9, file)
		export_all_text_several_q(_xml_tree, '10b', 6, file)
		export_all_text_several_q(_xml_tree, '16', 11, file)
		export_all_text_choices(_xml_tree, '17', 5, file)
		export_all_text_several_q(_xml_tree, '18', 7, file)
		export_all_text_several_q(_xml_tree, '19', 12, file)
		export_all_text_several_q(_xml_tree, '20', 1, file)
		export_all_text_several_q(_xml_tree, '20', 2, file)
		export_all_text_several_q(_xml_tree, '20', 3, file)
		export_all_text_several_q(_xml_tree, '21a', 1, file)
		export_all_text_several_q(_xml_tree, '21a', 2, file)
		export_all_text_several_q(_xml_tree, '21a', 3, file)
		export_all_text_choices(_xml_tree, '21b', 4, file)
		export_all_text_several_q(_xml_tree, '23', 9, file)
		export_all_text_several_q(_xml_tree, '24', 4, file)
		export_all_text_choices(_xml_tree, '25', 6, file)
		export_all_text_several_q(_xml_tree, '27', 19, file)
		export_all_text_choices(_xml_tree, '31', 6, file)
		export_all_text_choices(_xml_tree, '33', 6, file)
		export_all_text_choices(_xml_tree, '35', 10, file)
		export_all_text_choices(_xml_tree, '37', 5, file)
		export_all_text_choices(_xml_tree, '40', 6, file)
		export_all_text_choices(_xml_tree, '41', 6, file)
		export_all_text_choices(_xml_tree, '42', 4, file)
		export_all_text_several_q(_xml_tree, '43', 7, file)

	end

	def from_utf(text)
		if text
			text.unpack("U*").pack("C*")
		else
			nil
		end
	end

	def export_all_text_choices(xml_tree, q_number, ch_index, file)
		file.puts("Q#{q_number}, choice#{ch_index}") 
		get_answer_nodes(xml_tree, q_number).each { |answer_node|
			if answer_node.attributes['index'].to_i == ch_index
				file.write from_utf(answer_node.text) + "|"
			end
		}
		file.puts "\n"
	end

	def export_all_text_several_q(xml_tree, q_number, ch_index, file)
		file.puts("Q#{q_number}, choice#{ch_index}") 
		get_answer_nodes(xml_tree, q_number).each { |answer_node|
			value_node = answer_node.elements[ch_index]
			raise value_node.name unless value_node.name == 'value'
			str_val = value_node.attributes['string']
			if str_val && str_val.length > 0
				file.write from_utf(str_val) + "|"
			end
		}
		file.puts "\n"
	end
end
